﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Net;
using System.IO;

using System.Web; //Add reference to System.Web
using System.Runtime.Serialization.Json; //Add reference to System.Runtime.Serialization

namespace RedCritterConnecter.Samples
{
    //Create a class to contain the response

    public class HasHadBadgeResponse
    {   
        public Boolean Result { get; set; }
        public String HasHadBadge { get; set; }
    }


    public class HasHadBadge
    {

        public delegate void OnHasHadBadgeResponse(HasHadBadgeResponse HasHadBadgeResponse);
        public event OnHasHadBadgeResponse onHasHadBadgeResponse;

        public delegate void OnHasHadBadgeResponseError(HasHadBadgeResponse HasHadBadgeResponse);
        public event OnHasHadBadgeResponseError onHasHadBadgeResponseError;

        const string CONST_ConnecterBaseURL = "https://www.redcritterconnecter.com/";
  

        public void Execute(String SecretKey, String ProfileEntity, String BadgeName )
        {
            try
            {
                //Create url encoded parameters in query string
                String queryString = "secretkey=" + System.Web.HttpUtility.UrlEncode(SecretKey) + "&profileentity=" + System.Web.HttpUtility.UrlEncode(ProfileEntity) + "&badgename=" + System.Web.HttpUtility.UrlEncode(BadgeName);

                //Create a new instance of a WebClient
                WebClient wc = new System.Net.WebClient();

                //Prevent this request from caching in order to ensure that it is sent to server
                wc.CachePolicy = new System.Net.Cache.RequestCachePolicy(System.Net.Cache.RequestCacheLevel.NoCacheNoStore);

                //Attach an event handler to receive the response
                wc.DownloadStringCompleted += onHasHadBadgeResponseReceived;

                //Make the call
                            
                wc.DownloadStringAsync(new Uri(CONST_ConnecterBaseURL + "services/gamificationv1/HasHadBadge?" + queryString, UriKind.Absolute));
            }
            catch
            {
                //Something went wrong communicating with the server
                if (onHasHadBadgeResponseError != null)
                {
                    onHasHadBadgeResponseError(null);
                }
            }

        }

        private void onHasHadBadgeResponseReceived(object sender, DownloadStringCompletedEventArgs e)
        {
            try
            {
                //Create a JSON serializer
                System.Runtime.Serialization.Json.DataContractJsonSerializer s = new DataContractJsonSerializer(typeof(HasHadBadgeResponse));
               

                //Copy the string into a memory stream
                MemoryStream ms = new MemoryStream(Encoding.UTF8.GetBytes(e.Result));

                //Read the stream into an object matching the response's type
                HasHadBadgeResponse HasHadBadgeResponse = (HasHadBadgeResponse)s.ReadObject(ms);

                //Work with the populated response object
                if (HasHadBadgeResponse.Result == true)
                {
                    //Request was accepted, raise the success event
                    onHasHadBadgeResponse(HasHadBadgeResponse);
                }
                else
                {
                    //Something went wrong
                    if (onHasHadBadgeResponseError != null)
                    {
                        //Request failed, raise the error event
                        onHasHadBadgeResponseError(HasHadBadgeResponse);
                    }
                }
            }
            catch
            {
                //Something went wrong
                onHasHadBadgeResponseError(null);
            }
        }
    }
}
